<div align="center">

  <h1 align="center">Git Assistant</h1>
  <p align="center">Assists you to use git and .git in easy and simple way with robust API</p>

[![BSD-3-Clause License](https://img.shields.io/github/license/EhsanAramide/git-assistant?style=flat-square)](https://github.com/EhsanAramide/git-assistant/blob/master/LICENSE)
[![Dart Version](https://img.shields.io/badge/Dart-Null%20Safe-lightblue?style=flat-square)](https://dart.dev)
![Dart Platform Support](https://img.shields.io/badge/platform-linux%20|%20windows%20|%20macos-lightgrey?style=flat-square)
![Under Development](https://img.shields.io/badge/under%20development-red?style=flat-square)
[![Coverage Status](https://coveralls.io/repos/github/EhsanAramide/git-assistant/badge.svg?branch=master)](https://coveralls.io/github/EhsanAramide/git-assistant?branch=master)
[![Workflow status](https://github.com/EhsanAramide/git-assistant/actions/workflows/CI_CD.yml/badge.svg)](https://github.com/EhsanAramide/git-assistant/actions)
[![pub](https://img.shields.io/pub/v/git_assistant.svg)](https://pub.dev/packages/git_assistant)

</div>
<hr/>

## Features

#### Implemented

- Command generator and executor

  - Generates command sequence

  ```dart
  var git = Git();
  print(git.log.prettyOpt(PF.oneline)); // 'git log --pretty=oneline'
  print(git.log); // 'git log'
  ```

  - Executes command sequence

  ```dart
  var git = Git();
  // Executes 'git log --pretty=tformat:commit hash = %H' and returns stdout
  git.log.prettyOpt('commit hash = ${PP.commitHash.string}').exec();
  git.log.exec(); // Executes 'git log'
  ```

- Git commands support

  - Log - command

    - Pretty - option

    ```dart
    // you can use pretty option with two formatting choices:
    // 1. Basic formatter in PF enum such email, oneline and etc.
    // 2. Custom formatter which use tformat and placeholders in PP.
    var git = Git();
    git.log.prettyOpt(PF.oneline).exec(); // 'git log --pretty=oneline'
    // 'git log --pretty=tformat:commit %H'
    print(git.log.prettyOpt('commit ${PP.commitHash.string}'));
    ```

**You can see feature implementation todo in repository projects**

## License

Distributed under the BSD-3-Clause License. See [`LICENSE`](https://github.com/EhsanAramide/git-assistant/blob/master/LICENSE) for more information.
