part of '../../../git_assistant.dart';

/// The enum Pretty Formatter selector.
enum PF {
  full,
  fuller,
  email,
  medium,
  oneline,
  short,
  raw,
}

/// [PF] Extension wrapper to generate string form of the enum instance.
extension PFExtension on PF {
  /// Returns string of the current instance.
  String get string => toString().split('.').last;
}

/// The enum Pretty Placeholder selector.
enum PP {
  commitHash,
  treeHash,
  parentHashes,
  authorName,
  authorEmail,
  authorDate,
  committerName,
  committerEmail,
  committerDate,
  refName, // TODO: maybe ref names without ( and ) [%D placeholder]
  encoding,
  subject,
  body,
  commitNote,
  newLine,
}

/// [PP] Extension wrapper to generate string form of the enum instance.
extension PPExtension on PP {
  /// Returns equivalent placeholder from enum instance.
  String get string {
    switch (this) {
      case PP.commitHash:
        return '%H';
      case PP.treeHash:
        return '%T';
      case PP.parentHashes:
        return '%P';
      case PP.authorName:
        return '%an';
      case PP.authorEmail:
        return '%ae';
      case PP.authorDate:
        return '%ad';
      case PP.committerName:
        return '%cn';
      case PP.committerEmail:
        return '%ce';
      case PP.committerDate:
        return '%cd';
      case PP.refName:
        return '%d';
      case PP.encoding:
        return '%e';
      case PP.subject:
        return '%s';
      case PP.body:
        return '%b';
      case PP.commitNote:
        return '%N';
      case PP.newLine:
        return '%n';
    }
  }
}
