import 'dart:io';

import 'package:git_assistant/git_assistant.dart';
import 'package:test/test.dart';

void main() {
  group('LogGitChain class', () {
    var git = Git();

    test('test log command generator', () {
      expect(
        git.log.prettyOpt(PF.short).toString(),
        'git log --pretty=short',
      );
      expect(
        git.log.prettyOpt('commit is ${PP.commitHash.string}').toString(),
        'git log --pretty=tformat:commit is %H',
      );
      expect(
        // ignore: invalid_use_of_protected_member
        git.log.prettyOpt('author is ${PP.newLine.string}').argList,
        ['git', 'log', '--pretty=tformat:author is %n'],
      );
      expect(
        // ignore: invalid_use_of_protected_member
        git.log.prettyOpt(PF.fuller).argList,
        ['git', 'log', '--pretty=fuller'],
      );

      expect(() => git.log.prettyOpt(123124), throwsException);
    });

    test('test log command executor', () {
      expect(
        git.log.prettyOpt(PF.raw).exec(),
        Process.runSync('git', ['log', '--pretty=raw']).stdout,
      );
      expect(
        git.log
            .prettyOpt('Committer date => ${PP.committerDate.string}')
            .exec(),
        Process.runSync(
          'git',
          ['log', '--pretty=tformat:Committer date => %cd'],
        ).stdout,
      );
    });
  });
}
