#!/bin/bash

set -e

echo "Activate 'coverage' package..."
dart pub global activate coverage

echo "Running coverage process..."
dart test -r compact --coverage coverage/

echo "Generating LCOV report..."
format_coverage \
    --lcov \
    --in=coverage/test \
    --out=coverage/lcov.info \
    --packages=.packages \
    --report-on=lib \
    --check-ignore

